import urllib.request
import os
import sys

if len(sys.argv) < 2:
    raise Exception('Please enter a list name and run the following command: "python download_cath_list.py list.txt".')
else:
    file_name = sys.argv[1]


output_dir = 'downloaded_pdbs/'
if not os.path.isdir(output_dir):
    os.system('mkdir ' + output_dir)

# Make list of names
counter = 0
chain_list = []
with open(file_name, 'r') as f:
    while True:
        line = f.readline().rstrip()
        if not line: break
        line = line.split(',')
        chain_list.append(line[0])
        counter += 1

# Download with progress reporting.
dom_count = len(chain_list)
counter = 0
failed_count = 0
failed_file = open(output_dir + 'failed_list','w')
for chain_name in chain_list:
    if (counter >= 0) and (not os.path.isfile(output_dir + chain_name + '.pdb')):        
        try:
            url = 'http://www.cathdb.info/version/v4_2_0/api/rest/id/' + chain_name + '.pdb'
            print("Downloading: " + chain_name + ".pdb")
            urllib.request.urlretrieve(url, output_dir + chain_name + '.pdb')
        except Exception:
            try:
                url = 'http://www.cathdb.info/version/v4_1_0/api/rest/id/' + chain_name + '.pdb'
                print("Downloading: " + chain_name + ".pdb")
                urllib.request.urlretrieve(url, output_dir + chain_name + '.pdb')
            except:
                print("Failed!")
                failed_file.write(chain_name + '\n')
                failed_count += 1
    else:
        pass
    counter += 1
    print('Processed ' + chain_name + '.pdb  (' + str(counter) + '/' + str(dom_count) + ')' + '   Failed: ' + str(failed_count))
failed_file.close()
